/*********************** Cruft for VMS follows ****************************/
#include descrip
#include iodef
#include ssdef
#include ttdef
#include tt2def

static $DESCRIPTOR (term_name, "SYS$INPUT:");
static $DESCRIPTOR (ctrlc_message, "{control-C}");
struct char_buffer_type { unsigned short int dummy;
			  unsigned short int size;
			  unsigned long int tchars;
			  unsigned long int tchars2; } oldbuf, newbuf;
short term_chan;
static int first = 1;
static int in_pos, in_len;
static volatile int interrupt_flag;
static long outband_mask[2] = { 0, 16 };
static unsigned char buffer[20];

int CURinterrupt ( clear_flag )
    int clear_flag;
{
    if ( interrupt_flag ) {
	int temp = interrupt_flag;
	if ( clear_flag ) interrupt_flag = 0;
	return temp;
    }
    return 0;
}

static int control_c_ast ( )
{
    int status;
    short iosb[4];
    interrupt_flag = 1;
    status = sys$qiow ( 0, term_chan, IO$_SETMODE|IO$M_CTRLCAST, 
	&iosb, 0, 0,
	&control_c_ast, &outband_mask, 0, 0, 0, 0 );
}

/*
 * Define local replacement for wgetch that returns the characters without
 * having to set the terminal /pasthru, which screws up control-Y processing.
 */
int w_getch ( win )
   int win;
{
   int status;
   unsigned short iosb[4];
   if ( in_pos < in_len ) { return (buffer[in_pos++]); }
   status = sys$qiow ( 0, term_chan, IO$_READVBLK|IO$M_NOECHO|IO$M_NOFILTR,
	&iosb, 0, 0, &buffer, 1, 0, 0, 0, 0 );

   if ( (status&1) == 1 ) status = iosb[0];
   if ( status == SS$_PARTESCAPE ) {
	/* escape sequence in progress, fake a successful read */
	status = 1;
   }
   if ( (status&1) != 1 ) exit ( status );
   in_pos = 1;
   in_len = iosb[1] + iosb[3];
   return ( buffer[0] );
}

void
setterm_pas()
{
  int status;
  short iosb[4];
  sys$assign(&term_name,&term_chan,0,0);

  if(first==1) sys$qiow(0,term_chan,IO$_SENSEMODE,0,0,0,&oldbuf,12,0,0,0,0);
  first = 0;
  newbuf = oldbuf;

  /* set initial control-C AST on channel */
  in_pos = 0; in_len = 0;
   interrupt_flag = 0;
   status = sys$qiow ( 0, term_chan, IO$_SETMODE|IO$M_CTRLCAST, 
	&iosb, 0, 0,
	&control_c_ast, &outband_mask, 0, 0, 0, 0 );
   if ( (status&1) != 1 ) {
        printf("Can't set terminal mode. If you are running Hytelnet\n");
        printf("from a command file, be sure to reassign sys$input,\n");
        printf("eg. $ assign /user sys$command sys$input.\n");
        exit (0);
   }
}

void
resetterm_pas()
{
  sys$qiow(0,term_chan,IO$_SETMODE,0,0,0,&oldbuf,12,0,0,0,0);
  sys$dassgn(term_chan);
}


/* VMS doesn't have termcap.  Unfortunately, the code in this */
/* module uses termcap just a little bit (it really shouldn't) */
/* rather than doing everything through curses */
 
/* The following simulates tputs, but does not support padding */
tputs(cp, affcnt, outc)
     register char *cp;
     int affcnt;
     int (*outc)();
{
      while (*cp)
        outc(*(cp++));
}


#ifdef NEEDS_STRCASECMP
/*
 * Copyright (c) 1987 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Modified for use on VMS by Earl Fogel, University of Saskatchewan
 * Computing Services, January 1992
 */
#include <stddef.h>
typedef unsigned char u_char;

/*
 * This array is designed for mapping upper and lower case letter
 * together for a case independent comparison.  The mappings are
 * based upon ascii character sequences.
 */
static const u_char charmap[] = {
	'\000', '\001', '\002', '\003', '\004', '\005', '\006', '\007',
	'\010', '\011', '\012', '\013', '\014', '\015', '\016', '\017',
	'\020', '\021', '\022', '\023', '\024', '\025', '\026', '\027',
	'\030', '\031', '\032', '\033', '\034', '\035', '\036', '\037',
	'\040', '\041', '\042', '\043', '\044', '\045', '\046', '\047',
	'\050', '\051', '\052', '\053', '\054', '\055', '\056', '\057',
	'\060', '\061', '\062', '\063', '\064', '\065', '\066', '\067',
	'\070', '\071', '\072', '\073', '\074', '\075', '\076', '\077',
	'\100', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\133', '\134', '\135', '\136', '\137',
	'\140', '\141', '\142', '\143', '\144', '\145', '\146', '\147',
	'\150', '\151', '\152', '\153', '\154', '\155', '\156', '\157',
	'\160', '\161', '\162', '\163', '\164', '\165', '\166', '\167',
	'\170', '\171', '\172', '\173', '\174', '\175', '\176', '\177',
	'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
	'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
	'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
	'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
	'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
	'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
	'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
	'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
	'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
	'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
	'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
	'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
	'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
	'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
	'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
	'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

int
strcasecmp(s1, s2)
	const char *s1, *s2;
{
	register const u_char *cm = charmap,
			*us1 = (const u_char *)s1,
			*us2 = (const u_char *)s2;

	while (cm[*us1] == cm[*us2++])
		if (*us1++ == '\0')
			return (0);
	return (cm[*us1] - cm[*--us2]);
}

int
strncasecmp(s1, s2, n)
	const char *s1, *s2;
	register size_t n;
{
	if (n != 0) {
		register const u_char *cm = charmap,
				*us1 = (const u_char *)s1,
				*us2 = (const u_char *)s2;

		do {
			if (cm[*us1] != cm[*us2++])
				return (cm[*us1] - cm[*--us2]);
			if (*us1++ == '\0')
				break;
		} while (--n != 0);
	}
	return (0);
}

#endif
